<script lang="ts">
  import type { Settings as SettingsType } from "../server";
  import { GameMode } from "../server";
  import { createEventDispatcher } from "svelte";
  import { defaultSettings, possiblePlayerCounts } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: SettingsType = defaultSettings;
  export let readonly: boolean = false;

  const modes = [GameMode.Modern, GameMode.Classic];

  let mode: GameMode = settings.mode;

  let playerCounts: number[];
  $: playerCounts = possiblePlayerCounts[mode];

  playerCounts = settings.selectedPlayerCounts;

  $: settingsChange = {
    mode,
    selectedPlayerCounts: playerCounts,
  };

  $: dispatch("settings_change", settingsChange);
</script>

<section>
  <div>
    <header>Game mode</header>
    <ul>
      {#each modes as modeOption}
        <li>
          <label>
            <input
              type="radio"
              bind:group={mode}
              value={modeOption}
              disabled={readonly}
            />
            {modeOption}
          </label>
        </li>
      {/each}
    </ul>
  </div>
  <div>
    <header>Player counts</header>
    <ul>
      {#each possiblePlayerCounts[mode] as playersOption}
        <li>
          <label>
            <input
              type="checkbox"
              bind:group={playerCounts}
              value={playersOption}
              disabled={readonly}
            />
            {playersOption}
          </label>
        </li>
      {/each}
    </ul>
  </div>
</section>

<style>
  ul {
    margin-top: 0.25rem;
    margin-bottom: 1rem;
    display: flex;
    gap: 1rem;
  }
</style>
